import 'package:bird_cryptography/bird_cryptography.dart';
import 'package:bird_flutter/bird_flutter.dart';
import 'package:flutter/cupertino.dart';
import 'package:neptune_cryptography_example/elements.dart';
import 'package:neptune_cryptography_example/widgets/input.dart';

// ignore_for_file: close_sinks
class _EncodingBloc extends HookBloc {
  final Signal<String> source = HookBloc.disposeSink(Signal(""));
  final Signal<CryptographicDataEncoding> encodingFrom = HookBloc.disposeSink(
      Signal(e_utf8));
  final Signal<String> target = HookBloc.disposeSink(Signal(""));
  final Signal<CryptographicDataEncoding> encodingTo = HookBloc.disposeSink(
      Signal(e_hex));

  void convert() {
    try {
      final _source = encodingFrom.value.decode(source.value);
      try {
        target.add(encodingTo.value.encode(_source));
      } catch (e) {
        target.add("Invalid output encoding $e");
      }
    } catch (e) {
      target.add("Invalid input/encoding $e");
    }
  }
}

class EncodingPage extends StatelessWidget {
  @override
  Widget build(BuildContext context) {
    return $$ >> (context) {
      final bloc = $$$(() => _EncodingBloc());

      return center() & singleChildScrollView() > onColumnMinCenterCenter() >> [
        encodingWaved(just(false), bloc.encodingFrom),
        verticalSpace(8.0),
        signalInputWidget(signal: bloc.source, label: just("Input")),

        verticalSpace(24.0),

        encodingWaved(just(false), bloc.encodingTo),
        verticalSpace(8.0),
        signalInputWidget(signal: bloc.target, label: just("Output")),

        flatButton(bloc.convert) > const Text("Convert"),
      ];
    };
  }
}