import 'package:bird_cryptography/bird_cryptography.dart';

abstract class CryptoCipher<T extends CryptoParameter> {
  const CryptoCipher();

  List<int> encrypt(List<int> data, T params);

  List<int> decrypt(List<int> data, T params);
}

abstract class CryptographyCiphers {
  static const CryptographyCiphers dart = PointycastleCiphers();

  CryptoCipher<CryptoParametersPWAndIV> aes_cbc();

  CryptoCipher<CryptoParametersPWAndIV> aes_ctr();

  CryptoCipher<CryptoParametersPW> aes_ecb();
}
