import 'dart:typed_data';

/// Used by cryptographic operations that map one value to another like hashes
abstract class SimpleDigest {
  const SimpleDigest();

  List<int> digestRaw(Uint8List intList);
}

/// Used by cryptographic operations that convert a raw value and a password to a single value
/// like HMACs or KDFs
abstract class SimplePWDigest {
  const SimplePWDigest();

  List<int> digestRaw(Uint8List intList, List<int> pw);
}
