import 'package:meta/meta.dart';
import 'package:bird_cryptography/bird_cryptography.dart';

abstract class KDFCrypto extends SimplePWDigest {
  const KDFCrypto();
}

abstract class CryptographyKDF {
  static const CryptographyKDF dart = PointycastleCryptographyKDF();

  KDFCrypto sha256_pbkdf2({
    @required int i,
    @required int length,
  });

  KDFCrypto sha384_pbkdf2({
    @required int i,
    @required int length,
  });

  KDFCrypto sha512_pbkdf2({
    @required int i,
    @required int length,
  });

  KDFCrypto scrypt({
    @required int n,
    @required int r,
    @required int p,
    @required int length,
  });
}
